# -*- coding: iso-8859-1 -*-
"""
Programme du couplage entre HOMARD et Code_Aster
"""
__revision__ = "V2.0"
#
import os
import sys
#
from aster_homard_1             import aster_homard_1
from aster_homard_2             import aster_homard_2
from aster_homard_3             import aster_homard_3
from aster_homard_4             import aster_homard_4
from aster_homard_5             import aster_homard_5
#
def aster_homard (arguments) :
#
  """

   Arguments :
     1. Repertoire de reference de HOMARD sur la machine
     2. Sous-repertoire dans lequel aura lieu l'execution de homard
     3. Version de HOMARD
     4. Niveau d'information au sens ASTER
     5. Nom du fichier de donnes en mode information, 0 sinon 
     N. rien, si version publique de HOMARD
        -PERSO, si version personnelle
     N. rien, si silencieux
        -verbose, sinon

   Remarque : ces arguments sont transmis sous forme d'une chane de caractres
  """
#
# 1. Initialisation
#
  message_erreur = None
#
###  blabla = "\nDans " + sys.argv[0] + ", avant appel a aster_homard_"
#
  rep_calc_aster = os.getcwd()
#
#  constantes :
  environnement = { "fic_conf" : "HOMARD.Configuration", 
                    "rep_calc_aster" : rep_calc_aster }
#
# 2. Decodage des arguments
#
###  print blabla, "1, :", "\narguments :", arguments
  dict_arguments = aster_homard_1 (arguments)
###  print "dans", __name__, "\ndict_arguments = ", dict_arguments
#
  erreur = dict_arguments["code_de_retour"]
  verbose = dict_arguments["verbose"]
#
# 3. On passe dans le sous-repertoire de calcul pour homard
#
  if not erreur :
    rep_calc_logiciel = dict_arguments ["rep_calc_LOGICIEL"]
    if verbose :
      print "\n.. rep_calc_logiciel :", rep_calc_logiciel
    codret_partiel = [0]
    try :
      os.chdir(rep_calc_logiciel)
    except os.error, codret_partiel :
      print "Code d'erreur de chdir : ", codret_partiel[0], ":", codret_partiel[1]
    if codret_partiel[0] != 0 :
      erreur = 2
#
# 4. Recupration des options dans le fichier de configuration
#
  if not erreur :
    fic_conf = environnement["fic_conf"]
###    print blabla, "2, :", "\nfic_conf :", fic_conf
    variables_conf = aster_homard_2 (dict_arguments, fic_conf)
    erreur = variables_conf["code_de_retour"]
#
# 5. Execution
#
  if not erreur :
###    print blabla, "3, :", "\ndict_arguments :", dict_arguments, "\nvariables_conf :", variables_conf
    code_retour_exec = aster_homard_3 (dict_arguments, variables_conf)
#
# 6. Manipulation sur les resultats produits
#
  if not erreur :
#    print blabla, "4, :", "\nenvironnement :", environnement, "\ndict_arguments :", dict_arguments, "\nvariables_conf :", variables_conf, "\ncode_retour_exec :", code_retour_exec
#    os.system("sleep 5")
    erreur = aster_homard_4 (environnement, dict_arguments, variables_conf, code_retour_exec)
    if code_retour_exec != 0 :
      erreur = 10
#
# 7. Apres une adaptation en mode perso, relance de HOMARD pour les figures
#
###  if not erreur :
###    if ( dict_arguments["PERSO"] == "oui" ) and ( variables_conf["ModeHOMA"] == 1 ) :
######      print blabla, "5, :", "\nenvironnement :", environnement, "\ndict_arguments :", dict_arguments, "\nvariables_conf :", variables_conf
###      erreur = aster_homard_5 (environnement, dict_arguments, variables_conf)
######      print "en sortie de aster_homard_5, erreur =", erreur
#
# 8. La fin
#
  os.chdir(rep_calc_aster)
###  os.system("sleep 3000")
#
  if erreur :
    message_erreur = str(erreur)
#
  return message_erreur
#
#
#=======================================================================================
#=======================================================================================
#
#
if __name__ == "__main__" :
#
  from aster_homard_utilitaires import verif
#
# 1. ==> Rcupration des arguments
#
  T1 = "/tmp/q"
  T1_refe = "1"
  message_erreur_test = aster_homard (T1)
  verif ("Test T1", T1_refe, message_erreur_test)
#
  sys.exit(message_erreur_test)
