# -*- coding: iso-8859-1 -*-
"""
Programme du couplage entre HOMARD et Code_Aster
"""
__revision__ = "V2.0"
#
import os
#
from aster_homard_utilitaires   import exec_commande
#
########################## Debut de la fonction ##################################
#
def aster_homard_3 (dict_arguments, variables_conf):
#
  """
   Arguments :
     1. Dictionnaire des arguments generaux
     2. Dictionnaire des variables de configuration
  """
#
# 1. code de retour :
  blabla = "\nDans " + __name__ + " :"
  messages_erreur = { 0 : "Tout va bien", 
                      3 : "L'excutable HOMARD est inconnu.", 
                     10 : "Problme  l'excution de HOMARD" }
#
#  print blabla, "\ndict_arguments :", dict_arguments, "\nvariables_conf :", variables_conf
#
  verbose = dict_arguments["verbose"]
  nuvers          = dict_arguments["nuvers"]
  if dict_arguments["PERSO"] == "oui" :
    rep_base_logiciel = dict_arguments["rep_pers_LOGICIEL"]
  else :
    rep_base_logiciel = dict_arguments["rep_refe_LOGICIEL"]
  fic_donn          = dict_arguments["fic_donn"]
#
# 2. Reperage de l'executable
#
  system = os.uname()[0]
  if dict_arguments["PERSO"] == "oui" :
    executable = os.path.join(rep_base_logiciel, nuvers, "Executables", system, "HOMARD.out")
  else :
    ajout = "HOMARD_"+nuvers+".out"
    executable = os.path.join(rep_base_logiciel, system, ajout)
#
  if os.path.isfile(executable) :
    erreur = 0
  else :
    print "Ce fichier est inconnu : ", executable
    erreur = 3
#
# 3. Lancement
#
  if not erreur :
    commande = executable
    modehoma = variables_conf["ModeHOMA"]
    if modehoma == 2 :
      commande = commande + "<" + fic_donn
    if verbose :
      print ".. Appel systeme pour", commande
    erreur = exec_commande (commande)
    if erreur :
      erreur = 10
#
# 4. La fin
#
  if erreur :
    print blabla, messages_erreur[erreur]
#    print blabla
#    print erreur
#
  return erreur
#
##########################  Fin de la fonction  ##################################
#
##########################       Auto-test      ##################################
#
if __name__ == '__main__' :
#
  from aster_homard_utilitaires import verif
#
  e1 = {"fic_conf" : "HOMARD.Configuration" }
  a1 = {"fic_donn" : "DONN", 'PERSO': "non", 'nuvers': 'V7.n', 'rep_refe_LOGICIEL': '/logiciels/HOMARD/HOMARD_PUBLIC'}
  v1 = {'ModeHOMA': 2 }
  l1_refe = 10
  l1_calc = aster_homard_3 (e1, a1, v1)
  verif ("Test sur l1", l1_refe, l1_calc)
#
  e2 = {"fic_conf" : "HOMARD.Configuration" }
  a2 = {"fic_donn" : "DONN", 'PERSO': "non", 'nuvers': 'V7.n', 'rep_refe_LOGICIEL': '/logiciefou/HOMOMARD_PUBLIC'}
  v2 = {'ModeHOMA': 2 }
  l2_refe = 3
  l2_calc = aster_homard_3 (e2, a2, v2)
  verif ("Test sur l2", l2_refe, l2_calc)
#
  fic_conf_test = "HOMARD.Configuration"
  fichier_test = open (fic_conf_test, 'w')
  s = "ModeHOMA 1\n"
  fichier_test.write(s)
  fichier_test.close()
  e3 = {"fic_conf" : fic_conf_test }
  a3 = {"fic_donn" : "DONN", 'PERSO': "oui", 'nuvers': 'V7.n', 'rep_pers_LOGICIEL': '/local/HOMARD'}
  v3 = {'ModeHOMA': 1 }
  l3_refe = 10
  l3_calc = aster_homard_3 (e3, a3, v3)
  verif ("Test sur l3", l3_refe, l3_calc)
  os.remove(fic_conf_test)
  os.remove("core")
