# -*- coding: iso-8859-1 -*-
"""
Programme du couplage entre HOMARD et Code_Aster
"""
__revision__ = "V2.0"
#
import string
#
########################## Debut de la fonction ##################################
#
#   Arguments :
#     1. Type de fonctionnement :
#        1 : creation du repertoire de calcul
#        2 : execution de homard
#     2. Sous-repertoire dans lequel aura lieu l'execution de homard
#
def aster_homard_1 (arguments):
#
  """docstring"""
#
# 1. code de retour :
  blabla = "\nDans " + __name__ + " :"
  messages_erreur = { 0 : "Tout va bien", 
                      1 : "Il manque des arguments.", 
                      2 : "Il y a trop d'arguments.", 
                      3 : "Le type de fonctionnement est mauvais." }
#
# 2. Decodage et stockage des arguments :
#  print blabla, arguments
#
# 2.1. Verification du nombre
#
  nbarg = len(arguments)
  if nbarg < 2 :
    codret = 1
  elif nbarg > 2 :
    codret = 2
  else :
    codret = 0
#
  dict_arguments = {}
#
  while codret == 0 :
#
# 2.2. Le mode de fonctionnement
#
    type_fonc = string.atoi(arguments[0])
    if type_fonc != 1 and type_fonc != 2 :
      print "Type de fonctionnement :", type_fonc
      codret = 3
      break
#
    dict_arguments ["type_fonc"] = type_fonc
#
# 2.3. Le repertoire du calcul HOMARD
#
    dict_arguments ["rep_calc_LOGICIEL"] = arguments[1]
#
    break
#
# 3. La fin
#
  if codret != 0 :
    print blabla, messages_erreur[codret]
#
  dict_arguments ["code_de_retour"] = codret
  return dict_arguments
#
##########################  Fin de la fonction  ##################################
#
##########################       Auto-test      ##################################
#
if __name__ == '__main__' :
#
  from aster_homard_utilitaires import verif
#
  l1 = ["1"]
  l1_refe = {'code_de_retour': 1}
  l1_calc = aster_homard_1 (l1)
  verif ("Test sur l1", l1_refe, l1_calc)
#
  l2 = ["1", "toto"]
  l2_refe = {'type_fonc': 1, 'code_de_retour': 0, 'rep_calc_LOGICIEL': 'toto'}
  l2_calc = aster_homard_1 (l2)
  verif ("Test sur l2", l2_refe, l2_calc)
#
  l3 = ["3", "toto"]
  l3_refe = {'code_de_retour': 3}
  l3_calc = aster_homard_1 (l3)
  verif ("Test sur l3", l3_refe, l3_calc)
