# -*- coding: iso-8859-1 -*-
"""
Programme du couplage entre HOMARD et Code_Aster
"""
__revision__ = "V2.0"
#
import os
#
from aster_homard_utilitaires   import lien
#
########################## Debut de la fonction ##################################
#
#   Arguments :
#     1. Repertoire de calcul pour ASTER
#     2. Dictionnaire des arguments generaux
#     3. Dictionnaire des variables de configuration
#
def aster_homard_5 (rep_calc_aster, dict_arguments, variables_conf) :
#
  """docstring"""
#
# 1. code de retour :
  blabla = "\nDans " + __name__ + " :"
  messages_erreur = { 0 : "Tout va bien", 
                      1 : "Impossible de creer des liens symboliques sur les donnees.", 
                      2 : "Impossible de creer des liens symboliques sur les resultats." }
#
#  print blabla, "\nrep_calc_aster :", rep_calc_aster, "\ndict_arguments :", dict_arguments, "\nvariables_conf :", variables_conf
  codret = 0
#
# 2. Liens symboliques sur les donnees
#
  liste = [ "CCMaiN__", "CCSolN__", "CCIndica" ]
  for mot_cle in liste :
    nro = dict_arguments [mot_cle+"nro"]
    if nro != 0 :
      fic = variables_conf [mot_cle+"_fic"]
      fic_depart = os.path.join(rep_calc_aster, "fort.%d"%nro)
      codret_partiel = lien (fic_depart, fic)
      if codret_partiel != 0 :
        codret = 1
        break
#
# 3. Liens symboliques sur les resultats
#
  liste = [ "CCMaiNP1", "CCSolNP1" ]
  for mot_cle in liste :
    nro = dict_arguments [mot_cle+"nro"]
    if nro != 0 :
      fic = variables_conf [mot_cle+"_fic"]
      fic_depart = os.path.join(rep_calc_aster, "fort.%d"%nro)
      codret_partiel = lien (fic_depart, fic, "oui")
      if codret_partiel != 0 :
        codret = 2
        break
#
# 4. La fin
#
  if codret != 0 :
    print blabla, messages_erreur[codret]
    print "Fichier de depart :", fic_depart
    print "Fichier d'arrivee :", fic
#
  return codret
#
##########################  Fin de la fonction  ##################################
#
##########################       Auto-test      ##################################
#
if __name__ == '__main__' :
#
  from aster_homard_utilitaires import verif
#
  a1 = {'CCMaiN__nro': 80, 'CCSolN__nro': 0, 'CCSolNP1nro': 0, 'CCIndicanro': 0, 'CCMaiNP1nro': 0}
  v1 = {'CCMaiN___fic': 'maill.n.MED' }
  l1_refe = 0
  l1_calc = aster_homard_5 (".", a1, v1)
  verif ("Test sur l1", l1_refe, l1_calc)
#
  a2 = {'CCMaiN__nro': 80, 'CCSolN__nro': 0, 'CCSolNP1nro': 0, 'CCIndicanro': 0, 'CCMaiNP1nro': 81}
  v2 = {'CCMaiN___fic': 'maill.n', 'CCMaiNP1_fic': 'maill.np1' }
  l2_refe = 0
  l2_calc = aster_homard_5 ("/tmp", a2, v2)
  verif ("Test sur l2", l2_refe, l2_calc)
