# -*- coding: iso-8859-1 -*-
"""
Programme du couplage entre HOMARD et Code_Aster
"""
__revision__ = "V2.0"
#
import os
import string
#
########################## Debut de la fonction ##################################
#
#   Arguments obligatoires :
#     1. Repertoire de reference de HOMARD sur la machine
#     2. Sous-repertoire dans lequel aura lieu l'execution de homard
#     3. Version de HOMARD
#     4. Niveau d'information au sens ASTER
#     5. Nom du fichier de donnes en mode information, 0 sinon 
#
#   Remarque : ces arguments sont transmis sous forme d'une chane de caractres
#
def aster_homard_1 (arguments):
#
  """docstring"""
#
# 1. code de retour :
  blabla = "\nDans " + __name__ + " :"
  messages_erreur = { 0 : "Tout va bien", 
                      1 : "Il manque des arguments.", 
                      2 : "Il y a trop d'arguments.", 
                      3 : "Le type de fonctionnement est mauvais.", 
                      4 : "La variable d'environnement HOMARD_USER n'est pas dfinie." }
#
# 2. Decodage et stockage des arguments :
###  print blabla, arguments
#
# 2.1. Verification du nombre
#
  l_arguments = arguments.split()
  nbarg = len(l_arguments)
  if nbarg < 5 :
    erreur = 1
  elif nbarg > 7 :
    erreur = 2
  else :
    erreur = 0
###  print l_arguments
#
  dict_arguments = {}
#
  while not erreur :
#
# 2.2. Repertoire de reference de HOMARD sur la machine
#
    dict_arguments ["rep_refe_LOGICIEL"] = l_arguments[0]
#
# 2.3. Sous-repertoire dans lequel aura lieu l'execution de homard
#
    dict_arguments ["rep_calc_LOGICIEL"] = l_arguments[1]
#
# 2.4. Version de HOMARD
#
    dict_arguments ["nuvers"] = l_arguments[2]
#
# 2.5. Niveau d'information au sens ASTER
#
    dict_arguments ["nivinf"] = string.atoi(l_arguments[3])
#
# 2.6. Nom du fichier de donnes, ou '0' si c'est sans objet
#
    dict_arguments ["fic_donn"] = l_arguments[4]
#
# 2.7. Est-ce une version personnelle ?
#
    dict_arguments ["PERSO"] = "non"
#
    if len ( dict_arguments ["nuvers"] ) > 5 :
      if dict_arguments ["nuvers"][-6:] == ".PERSO" :
#
        dict_arguments ["PERSO"] = "oui"
        daux = os.environ
        if daux.has_key("HOMARD_USER"):
          dict_arguments ["rep_pers_LOGICIEL"] = daux["HOMARD_USER"]
        else :
          erreur = 4
          break
        dict_arguments ["nuvers"] = dict_arguments ["nuvers"][:-6]
#
    break
#
# 3. La fin
#
  if erreur :
    print blabla, messages_erreur[erreur]
#
  dict_arguments ["code_de_retour"] = erreur
###  print dict_arguments
  return dict_arguments
#
##########################  Fin de la fonction  ##################################
#
##########################       Auto-test      ##################################
#
if __name__ == '__main__' :
#
  from aster_homard_utilitaires import verif
#
  l1 = "1"
  l1_refe = {"code_de_retour": 1}
  l1_calc = aster_homard_1 (l1)
  verif ("Test sur l1", l1_refe, l1_calc)
#
  l2 = "/tmp /tmp/tmp V6.n 1 toto" 
  l2_refe = {"rep_refe_LOGICIEL": "/tmp", "fic_donn": "toto", "PERSO": "non", "rep_calc_LOGICIEL": "/tmp/tmp", "code_de_retour": 0, "nivinf": 1, "nuvers": "V6.n"}
  l2_calc = aster_homard_1 (l2)
  verif ("Test sur l2", l2_refe, l2_calc)
#
  l3 = "/tmp /tmp/tmp V6.n 1 toto -PERSO /tmp/tmpperso" 
  l3_refe = {"rep_refe_LOGICIEL": "/tmp", "fic_donn": "toto", "rep_pers_LOGICIEL": "/tmp/tmpperso", "PERSO": "oui", "rep_calc_LOGICIEL": "/tmp/tmp", "code_de_retour": 0, "nivinf": 1, "nuvers": "V6.n"}
  l3_calc = aster_homard_1 (l3)
  verif ("Test sur l3", l3_refe, l3_calc)
#
  l4 = "/tmp /tmp/tmp V6.n 1 toto -PERSO /tmp/tmpperso gabuzome"
  l4_refe = {"code_de_retour": 2}
  l4_calc = aster_homard_1 (l4)
  verif ("Test sur l4", l4_refe, l4_calc)
