# -*- coding: iso-8859-1 -*-
"""
Programme du couplage entre HOMARD et Code_Aster
"""
__revision__ = "V2.0"
#
import os
import string
#
########################## Debut de la fonction ##################################
#
#   Arguments :
#     1. nom du fichier de configuration
#
def aster_homard_2 (fic_conf) :
#
  """docstring"""
#
# 1. code de retour :
  blabla = "\nDans " + __name__ + " :"
  messages_erreur = { 0 : "Tout va bien", 
                      1 : "Probleme de fichier de configuration." }
#
#  print blabla, "\nfic_conf :", fic_conf
  variables_conf = {}
#
# 2. Verification
#
  if not os.path.isfile(fic_conf) :
    print "Le fichier", fic_conf, "est inconnu."
    erreur = 1
  else :
    erreur = 0
#
  if not erreur :
#
# 2. Lecture du fichier
#    Chaque ligne est convertie en une liste 'ligne', puis stockee dans une liste 'les_lignes'
#
    les_lignes = []
#
    fichier = open (fic_conf, 'r')
#
    while 1:
      ligne = fichier.readline()
###      print ligne
      if not ligne:
        break
      mot = string.split(ligne)
      les_lignes.append(mot)
#
    fichier.close()
#
# 3. Recherche des infos necessaires
# 3.1. Le mode d'utilisation de HOMARD
#
    mot_cle = "ModeHOMA"
    for indice in range(len(les_lignes)) :
##      print les_lignes[indice][0:]
      if les_lignes[indice][0] == mot_cle :
        variables_conf [mot_cle] = string.atoi(les_lignes[indice][1])
        break
    modehoma = variables_conf [mot_cle]
#
# 3.2. Les autres options et informations liees aux fichiers
#
    mots_cles_option = [ "ListeStd", "NumeIter", "PPBasFic" ]
    mots_cles_fic = { "CCMaiN__":2  }
#
    if modehoma == 1 or modehoma == 3 :
      mots_cles_fic ["HOMaiN__"] = 3
      mots_cles_fic ["HOMaiNP1"] = 3
      mots_cles_fic ["CCMaiN__"] = 2
      mots_cles_fic ["CCMaiNP1"] = 2
      mots_cles_option.append("HOMaiNP1")
#
    if modehoma == 1 :
      mots_cles_fic ["CCIndica"] = 2
      mots_cles_fic ["CCSolN__"] = 2
      mots_cles_fic ["CCSolNP1"] = 2
#
    for mot_cle in mots_cles_option :
      for indice in range(len(les_lignes)) :
        if les_lignes[indice][0] == mot_cle :
          variables_conf [mot_cle] = les_lignes[indice][1]
          break
#
    for mot_cle in mots_cles_fic.keys() :
      place = mots_cles_fic[mot_cle] - 1
      for indice in range(len(les_lignes)) :
        if les_lignes[indice][0] == mot_cle :
          variables_conf [mot_cle+"_fic"] = les_lignes[indice][place]
          break
#    print variables_conf
#
# 4. La fin
#
  if erreur :
    print blabla, messages_erreur[erreur]
#
  variables_conf["code_de_retour"] = erreur
  return variables_conf
#
##########################  Fin de la fonction  ##################################
#
##########################       Auto-test      ##################################
#
if __name__ == '__main__' :
#
  from aster_homard_utilitaires import verif
  import tempfile
#
  l1 = "gabuzome"
  l1_refe = {'code_de_retour': 1}
  l1_calc = aster_homard_2 (l1)
  verif ("Test sur l1", l1_refe, l1_calc)
#
  fic_conf_test = tempfile.mktemp()
  fichier_test = open (fic_conf_test, 'w')
  s = "ModeHOMA 1\n"
  fichier_test.write(s)
  fichier_test.close()
  l2 = fic_conf_test
  l2_refe = {'ModeHOMA': 1, 'code_de_retour': 0}
  l2_calc = aster_homard_2 (l2)
  verif ("Test sur l2", l2_refe, l2_calc)
  os.remove(fic_conf_test)
#
