# -*- coding: iso-8859-1 -*-
"""
Programme d'installation de HOMARD

Copyright EDF-R&D 2004, 2005, 2006
"""
#
__revision__ = "V2.1"
#
import os
import string
import tempfile
#
########################## Debut de la fonction ##################################
#
def tue_rep (nomrep) :
#
  """
  supprime un rpertoire apres avoir fait le menage interne
  code de retour : 0 : Tout va bien
                   1 : Ce n'est pas un rpertoire
                   2 : Impossible d'y aller
                   3 : Impossible de faire la liste des fichiers
                   4 : Impossible de supprimer un lien sur un fichier ou un rpertoire
                   5 : Impossible de changer les droits sur un fichier
                   6 : Impossible de dtruire un fichier
                  10 : Impossible de dtruire un rpertoire
  """
###  print "\nArguments a l'entree de", __name__, ":", nomrep
#
# 1. C'est un rpertoire
#
  if os.path.isdir(nomrep) :
#
    erreur = 0
#
# 1.1. Menage du contenu du rpertoire
#
    erreur = menage_rep(nomrep)
###    print nomrep , ", erreur = ", erreur
###    print os.system ("ls -la "+nomrep)
#
# 1.2. Suppression du rpertoire lui-meme
#
    if not erreur :
      err = [0]
      try :
        os.rmdir (nomrep)
      except os.error, err :
        print "Probleme au rmdir, erreur numro ", err[0], ":", err[1]
        erreur = 10 
#
# 2. Ce n'est pas un rpertoire ?
#
  else :
#
    print nomrep, "n'est pas un rpertoire."
    erreur = 1
#
  return erreur
#
##########################  Fin de la fonction  ##################################
#
#
########################## Debut de la fonction ##################################
#
def menage_rep (nomrep) :
#
  """
  fait le menage d'un rpertoire
  code de retour : 0 : Tout va bien
                   1 : Ce n'est pas un rpertoire
                   2 : Impossible d'y aller
                   3 : Impossible de faire la liste des fichiers
                   4 : Impossible de supprimer un lien sur un fichier ou un rpertoire
                   5 : Impossible de changer les droits sur un fichier
                   6 : Impossible de dtruire un fichier
  """
###  print "\nArguments a l'entree de", __name__, ":", nomrep
#
# 1. C'est un rpertoire
#
  if os.path.isdir(nomrep) :
#
    erreur = 0
#
# 1.1. Passage dans le rpertoire
#
    err = [0]
    try :
      os.chmod  (nomrep, 0755)
    except os.error, err :
      print "Probleme au chmod, erreur numro ", err[0], ":", err[1]
      erreur = 1
#
# 1.2. Liste des fichiers/rpertoires contenus dans le rpertoire
#
    liste = [ ]
    if not erreur :
      err = [0]
      try :
        liste = os.listdir(nomrep)
      except os.error, err :
        print "Probleme au listdir, erreur numro ", err[0], ":", err[1]
        erreur = 3
###    print "\n... liste = ", liste
#
# 1.3. Menage des fichiers/rpertoires contenus dans le rpertoire
#
    for nomfic in liste :
#
      fic_total = os.path.join(nomrep, nomfic)
###      print "\n... Fichier ", nomfic, " : ", fic_total
#
      if os.path.islink (fic_total) :
###        print "... passage par le os.path.islink pour ", nomfic, " : ", fic_total
        err = [0]
        try :
          os.unlink (fic_total)
        except os.error, err :
          print "Probleme au unlink, erreur numro ", err[0], ":", err[1]
          erreur = 4
          break
#
      elif os.path.isdir(fic_total) :
###        print "... passage par le os.path.isdir pour ", nomfic, " : ", fic_total
        erreur = tue_rep(fic_total)
        if erreur :
          break
#
      else :
###        print "... passage par le else pour ", nomfic, " : ", fic_total
        err = [0]
        try :
          os.chmod  (fic_total, 0755)
        except os.error, err :
          print "Probleme au chmod, erreur numro ", err[0], ":", err[1]
          erreur = 5
          break
        err = [0]
        try :
          os.remove (fic_total)
        except os.error, err :
          print "Probleme au remove, erreur numro ", err[0], ":", err[1]
          erreur = 6
          break
#
# 2. Ce n'est pas un rpertoire ?
#
  else :
#
    print nomrep, "n'est pas un rpertoire."
    erreur = 1
#
  return erreur
#
##########################  Fin de la fonction  ##################################
#
#
########################## Debut de la fonction ##################################
#
def lien (fic_depart = "d", fic_arrivee = "d", destruction = "non") :
#
  """
  On veut  fic_arrivee --> fic_depart
  c'est a dire la commande UNIX : ln -s $fic_depart $fic_arrivee

  Arguments obligatoire :
    1. Fichier depart du lien : c'est le "vrai" fichier
    2. Fichier arrivee du lien : c'est le lien
  Arguments optionnel :
    3. D pour detruire le fichier de depart. Par defaut, on n'y touche pas

  """
#  print "Arguments a l'entree de", __name__, ":", fic_depart, fic_arrivee, destruction
#
#  code de retour :
  messages_erreur = { 0 : "Tout va bien",
                      1 : "Suppression de lien impossible.",
                      2 : "Destruction de fichier impossible.",
                      3 : "Impossible de creer le lien symbolique." }
#
  erreur = 0
#
  while erreur == 0 :
#
    erreur_partiel = [0]
#
# 1. Destruction du fichier d'arrivee
#
# 1.1. C'est un lien
#
    if os.path.islink(fic_arrivee) :
      try :
        os.unlink(fic_arrivee)
      except os.error, erreur_partiel :
        print "Probleme a la suppression du lien sur le fichier d'arrivee", fic_arrivee
        print "Code d'erreur de unlink : ", erreur_partiel[0], ":", erreur_partiel[1]
        erreur = 1
        break
#
# 1.2. C'est un vrai fichier
#
    if os.path.isfile(fic_arrivee) :
      try :
        os.remove(fic_arrivee)
      except os.error, erreur_partiel :
        print "Probleme a la destruction du fichier d'arrivee", fic_arrivee
        print "Code d'erreur de remove : ", erreur_partiel[0], ":", erreur_partiel[1]
        erreur = 2
        break
#
# 2. Destruction eventuelle du fichier de depart
#
    if destruction != "non" :
      if os.path.isfile(fic_depart) :
        try :
          os.remove(fic_depart)
        except os.error, erreur_partiel :
          print "Probleme a la destruction du fichier de depart", fic_depart
          print "Code d'erreur de remove : ", erreur_partiel[0], ":", erreur_partiel[1]
          erreur = 2
          break
#
# 3. On peut faire le lien
#
    try :
      os.symlink(fic_depart, fic_arrivee)
    except os.error, erreur_partiel :
      print "Probleme au lien entre", fic_depart, "et", fic_arrivee
      print "Code d'erreur de symlink : ", erreur_partiel[0], ":", erreur_partiel[1]
      erreur = 3
      break
#
    break
#
# 4. La fin
#
  if erreur :
    print messages_erreur[erreur]
#
  return erreur
#
##########################  Fin de la fonction  ##################################
#
########################## Debut de la fonction ##################################
#
def exec_commande (arguments) :
#
  """
  Arguments :
    1. Nom de la commande a executer

  Au retour on a 0 ou 1 selon que cela a marche ou non
  """
#
#  print "Arguments a l'entree de", __name__, ":", arguments
#
# 1. Execution
#
  commande = arguments[0:]
  erreur = os.system (commande)
#
# 2. La fin
#
  if erreur :
    print "\nDans le rpertoire :", os.getcwd()
    print "Erreur a l'excution de :", commande
    print "Code de retour :", erreur
    if erreur != 256 :
      print os.strerror(erreur)
#
  return erreur
#
##########################  Fin de la fonction  ##################################
#
########################## Debut de la fonction ##################################
#
def verif (texte, reference, calcul) :
#
  """
  Arguments :
    1. Texte a afficher
    2. Resultat de reference
    3. Resultat a comparer
  """
#
  print texte, ":", 
  if reference == calcul :
    print "OK\n"
  else :
    print "echec"
    type_objet = type(calcul)
#    print type_objet
    dico = { }
    type_dictionnaire = type(dico)
    if type_objet == type_dictionnaire :
      for cle in reference.keys() :
        if not calcul.has_key(cle) :
          print "cle est present dans la rfrence, mais pas dans le calcul."
        else : 
          if reference[cle] != calcul[cle] :
            print "Pour ", cle, " : Reference = ", reference[cle]
            print "Pour ", cle, " : Calcul    = ", calcul[cle]
    else : 
      print "Reference :", reference
      print "Calcul    :", calcul, "\n"
#
##########################  Fin de la fonction  ##################################
#
########################## Debut de la fonction ##################################
#
def int_to_str2 (entier) :
#
  """
  transforme un entier compris entre 0 et 99 en une chaine sur deux caractres
  """
#
#  print "\nArguments a l'entree de", __name__, ":", entier
#
  if type(entier) == type(0) :
    la_chaine = str(entier)
    if entier < 10 :
      la_chaine = "0" + la_chaine
  else :
    la_chaine = None
#
  return la_chaine
#
##########################  Fin de la fonction  ##################################
#
########################## Debut de la fonction ##################################
#
def transfert_repd_repa (rep_depart, rep_arrivee, les_fichiers = "*", verbose = 0 ) :
#
  """
  Transfre le contenu du rpertoire rep_depart vers le rpertoire rep_arrivee

   Arguments obligatoire :
     1. Rpertoire de dpart du lien
     2. Rpertoire d'arrivee du lien
   Arguments optionnel :
     3. Le nom ou la liste du ou des fichiers  transfrer.
        Par defaut, on transfre tout le contenu du rpertoire de dpart
     4. Niveau des messages : 0, 1, >1

  code de retour : 0 : Tout va bien
                   1 : Ce n'est pas un rpertoire.
                   2 : Impossible d'aller dans le rpertoire de dpart.
                   3 : Problme  la constitution de l'archive.
                   4 : Impossible d'aller dans le rpertoire d'arrive.
                   5 : Problme  l'extraction de l'archive.
                   6 : Impossible de retourner dans le rpertoire initial.
  """
###  print "\nArguments a l'entree de", __name__, ":", rep_depart, rep_arrivee
#
  erreur = 0
  erreur_partiel = [0]
#
  messages_erreur = { 0 : "Tout va bien",
                      1 : "Ce n'est pas un rpertoire.",
                      2 : "Impossible d'aller dans le rpertoire de dpart.",
                      3 : "Problme  la constitution de l'archive.",
                      4 : "Impossible d'aller dans le rpertoire d'arrive.",
                      5 : "Problme  l'extraction de l'archive.",
                      6 : "Impossible de retourner dans le rpertoire initial." }
#
  repcou = os.getcwd()
#
  while erreur == 0 :
#
# 1. Controle des rpertoires
#
    for nomrep in [ rep_depart, rep_arrivee ] :
#
      if not os.path.isdir(nomrep) :
        erreur = 1
        print "Rpertoire", nomrep, ":"
#
    if erreur :
      break
#
# 2. Controle des fichiers  transfrer
#
    if les_fichiers == "*" :
      saux = les_fichiers
    else :
      if type(les_fichiers) == type("a") :
        saux = les_fichiers
      else :
        saux = " "
        for fic in les_fichiers :
          saux = saux + " " + fic
    if verbose > 1 :
      print "Fichiers  transfrer :", saux
#
# 3. Option d'archivage
#
    option_ar = "cf"
    option_detar = "xf"
    if verbose > 1 :
      option_ar = option_ar + "v"
      option_detar = option_detar + "v"
#
# 4. ==> Transfert
#
# 4.1. ==> Fichier temporaire
#
    fic_tar = tempfile.mktemp()
#
# 4.2. ==> Passage dans le rpertoire de dpart
#
    try :
      os.chdir(rep_depart)
    except os.error, erreur_partiel :
      print "Rpertoire de dpart", rep_depart
      print "Au changement de rpertoire, erreur numro" + str(erreur_partiel[0]) + " : " + str(erreur_partiel[1])
      erreur = 2
      break
#
# 4.3. ==> Archivage
#
    if verbose :
      print "....... Archivage depuis", rep_depart
#
    commande = "tar " + option_ar + " " + fic_tar + " " + saux
    erreur = exec_commande (commande)
    if erreur :
      erreur = 3
      break
#
# 4.4. ==> Passage dans le rpertoire d'arrive
#
###    os.system("ls -la "+rep_arrivee)
    try :
      os.chdir(rep_arrivee)
    except os.error, erreur_partiel :
      print "Rpertoire d'arrive", rep_arrivee
      print "Au changement de rpertoire, erreur numro" + str(erreur_partiel[0]) + " : " + str(erreur_partiel[1])
      erreur = 4
      break
#
# 4.5. ==> Extraction
#
    if verbose :
      print "....... Extraction dans", rep_arrivee
#
    commande = "tar " + option_detar + " " + fic_tar
    erreur = exec_commande (commande)
    if erreur :
      erreur = 5
      break
#
# 4.6. ==> Mnage du fichier d'archive
#
    try :
      os.remove (fic_tar)
    except os.error, erreur_partiel :
      print "Fichier d'archivage", fic_tar
      print "Probleme au remove, erreur numro ", erreur_partiel[0], ":", erreur_partiel[1]
      erreur = 5
      break
#
# 5. ==> Retour dans le rpertoire courant
#
    try :
      os.chdir(repcou)
    except os.error, erreur_partiel :
      print "Rpertoire initial", repcou
      print "Au changement de rpertoire, erreur numro" + str(erreur_partiel[0]) + " : " + str(erreur_partiel[1])
      erreur = 6
      break
#
# 6. La fin
#
    break
#
  if erreur :
    print messages_erreur[erreur]
#
  return erreur
#
##########################  Fin de la fonction  ##################################
#
########################## Debut de la fonction ##################################
#
def nettoyage () :
#
  """
  Nettoie les fichiers lis  un passage de test HOMARD dans le rpertoire courant
  """
#
#  print "\nEntree de", __name__"
#
  erreur = 0
#
  liste_brute = [ "Information.donn" ]
  liste_aux = [ "HOMARD", "Adaptation", "Interf_Ap_Ad", "Interf_Av_Ad", "Information" ]
  for pref in liste_aux :
    liste_brute.append(pref+".Configuration")
#
  liste_fic = os.listdir(os.curdir)
#
  for fic in liste_fic :
#  C'est un fichier
    if os.path.isfile(fic) :
#
      a_tuer = 0
#
#   Le fichier est directement  supprimer
      if fic in liste_brute :
        a_tuer = 1
#    Le nom du fichier comporte un .
      elif '.' in fic :
#      On dcompose selon le(s) point(s)
        laux = fic.split('.')
        lgaux = len(laux)
#        print fic, laux, lgaux
#
        if laux[0] == "maill" or laux[0] == "indic" or laux[0] == "Liste" :
          a_tuer = 1
        elif lgaux == 2 :
          if laux[0] == "info" :
            a_tuer = 1
        elif lgaux == 3 :
          if laux[0] == "donn" and laux[2] == "info" :
            a_tuer = 1
          elif laux[0] == "donn" and laux[2] == "info_avant" :
            a_tuer = 1
          elif laux[0] == "donn" and laux[2] == "info_apres" :
            a_tuer = 1
          elif laux[0] == "info_av" and laux[2] == "bilan" :
            a_tuer = 1
          elif laux[0] == "info_ap" and laux[2] == "bilan" :
            a_tuer = 1
          elif laux[0] == "avad" and laux[2] == "bilan" :
            a_tuer = 1
          elif laux[0] == "apad" and laux[2] == "bilan" :
            a_tuer = 1
          elif laux[0] == "verif_homa" and laux[2] == "bilan" :
            a_tuer = 1
          elif laux[0] == "verif_adap" and laux[2] == "bilan" :
            a_tuer = 1
          elif laux[0] == "verif_avad" and laux[2] == "bilan" :
            a_tuer = 1
          elif laux[0] == "verif_info_av" and laux[2] == "bilan" :
            a_tuer = 1
          elif laux[0] == "verif_info_ap" and laux[2] == "bilan" :
            a_tuer = 1
        elif lgaux == 4 :
          if laux[3] == "ps" :
            a_tuer = 1
          elif laux[0] == "info" and laux[3] == "data" :
            a_tuer = 1
          elif laux[0] == "indic" and laux[3] == "dat" :
            a_tuer = 1
          elif laux[0] == "indic" and laux[3] == "hist" :
            a_tuer = 1
          elif laux[0] == "qual" and laux[3] == "dat" :
            a_tuer = 1
          elif laux[0] == "HOMARD" and laux[1] == "Configuration" and laux[3] == "info" :
            a_tuer = 1
          elif laux[0] == "HOMARD" and laux[1] == "Configuration" and laux[3] == "info_avant" :
            a_tuer = 1
          elif laux[0] == "HOMARD" and laux[1] == "Configuration" and laux[3] == "info_apres" :
            a_tuer = 1
          elif laux[0] == "Information" and laux[1] == "Configuration" and laux[3] == "info" :
            a_tuer = 1
          elif laux[0] == "Information" and laux[1] == "Configuration" and laux[3] == "info_avant" :
            a_tuer = 1
          elif laux[0] == "Information" and laux[1] == "Configuration" and laux[3] == "info_apres" :
            a_tuer = 1
          elif laux[0] == "Interf_Av_Ad" and laux[1] == "Configuration" and laux[3] == "avad" :
            a_tuer = 1
          elif laux[0] == "Interf_Ap_Ad" and laux[1] == "Configuration" and laux[3] == "apad" :
            a_tuer = 1
        elif lgaux == 5 :
          if laux[0] == "HOMARD" and laux[1] == "Configuration" and laux[3] == "vers" :
            a_tuer = 1
          elif laux[0] == "Adaptation" and laux[1] == "Configuration" and laux[3] == "vers" :
            a_tuer = 1
#
#   On supprime ?
      if a_tuer :
#	print "On supprime", fic
#	pass
        err = [0]
        try :
          os.remove(fic)
        except os.error, err :
          print "Fichier : ", fic, "Problme au remove : ", err[0], ":", err[1]
          erreur = 1
#      else :
#	print "On garde", fic
#
  return erreur
#
##########################  Fin de la fonction  ##################################
#
########################## Debut de la fonction ##################################
#
def cree_rep_trav (environnement) :
#
  """
 cree un repertoire de travail
   Argument obligatoire :
     1. Dictionnaire de l'environnement  enrichir

     On y mettra le nom du repertoire de travail cree

  code de retour : 0 : tout va bien
                   1 : probleme
  print "Arguments a l'entree de", __name__, ":", environnement
  """
#
# 1. Creation du repertoire
#
  rep_trav = tempfile.mktemp()
#  print "Creation du repertoire", rep_trav
  os.mkdir (rep_trav)
#
  environnement ["rep_trav"] = rep_trav
#
  codret = 0
#
  environnement ["code_de_retour"] = codret
  return environnement
#
##########################  Fin de la fonction  ##################################
#
########################## Debut de la fonction ##################################
#
def lit_rep ( creation, message_question ) :
#
  """
 Lit le nom d'un rpertoire
 Cration ventuelle
  Retour : le nom complet du rpertoire
  """
#
  message = {}
  message["Ligne"] = "\n===============================================================\n"
  message["Repertoire_Nom"]        = "Nom du rpertoire : "
  message["Repertoire_Absent"]     = "Ce rpertoire n'existe pas."
  message["Repertoire_Creation"]   = "Voulez-vous le crer ? (o/n) \n"
  message["Repertoire_mkdir"]      = "A la cration de ce rpertoire"
  message["Erreur_Numero"]         = ", erreur numro "
#
  print message["Ligne"]
#
  encore = 1
  while encore :
#
    rep = raw_input(message_question)
#
    if len(rep) > 0 :
#
      aux = string.lstrip(rep)
      rep = string.rstrip(aux)
#
# 1. ==> Le rpertoire existe : tout va bien
#
      if os.path.isdir(rep) :
        encore = 0
      else :
#
# 2. ==> Le rpertoire n'existe pas
# 2.1. ==> Messages
#
        print message["Repertoire_Nom"], rep
        print message["Repertoire_Absent"]
#
# 2.2. ==> Cration sous condition
#
        if creation :
          var = raw_input(message["Repertoire_Creation"])
          if ( var == "o" or var == "y" ) :
            err = [0]
            try :
              os.mkdir(rep)
            except os.error, err :
              print message["Repertoire_mkdir"], message["Erreur_Numero"], err[0], ":", err[1]
            if not err[0] :
              encore = 0
#
# 3. ==> Etablissement du nom complet, propre
#
  rep_bis = os.path.join(os.getcwd(), rep)
  if os.path.isdir(rep_bis) :
    rep = rep_bis
  rep = os.path.normpath(rep)
#
  print message["Ligne"]
#
  return rep
#
##########################  Fin de la fonction  ##################################
#
##########################       Auto-test      ##################################
#
if __name__ == '__main__' :
#
  nomtemp = "/tagada/tsoin/tsoin"
  print tue_rep(nomtemp)
#
  nomtemp = tempfile.mktemp()
  print "\nCreation du repertoire", nomtemp
  os.mkdir(nomtemp)
  print tue_rep(nomtemp)
  print "\nDestruction du repertoire", nomtemp
#
  print lien ("/tmp/toto", "/tmp/tutu")
#
  print lien ("/tmp/toto", "/tmp/tutu", "oui")
#
  l1 = "ls -ltr $HOME"
  l1_refe = 0
  l1_calc = exec_commande(l1)
  verif ("Test sur exec_commande avec "+l1, l1_refe, l1_calc)
#
  d3 = { }
  d3_refe = {'code_de_retour': 0, 'rep_trav': '/tmp' }
  d3_calc = cree_rep_trav(d3)
  verif ("Test sur cree_rep_trav" , d3_refe, d3_calc)
#
  print transfert_repd_repa ("/tmps", "/tmp")
  print transfert_repd_repa ("/tmp", "/tmpu")
#  erreur = transfert_repd_repa ("/tmp", "/tmp")
  nomtemp = tempfile.mktemp()
  os.mkdir(nomtemp)
  os.system("touch "+os.path.join("/tmp", "glop"))
  erreur_main = transfert_repd_repa ("/tmp", nomtemp, "glop")
#
  l_aux = ["ga", "bu", "zo" , "me"]
  for fic_main in l_aux :
    os.system("touch "+os.path.join("/tmp", fic_main))
  erreur_main = transfert_repd_repa ("/tmp", nomtemp, l_aux, 1)
  print tue_rep(nomtemp)

