#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-
"""
Programme d'installation de HOMARD

Copyright EDF-R&D 2004, 2005, 2006
"""
#
__revision__ = "V2.0"
#
from HOMARD import utilitaires
#
import os
import shutil
import tempfile
import string
#
class INSTALLATION :
#
  """
  Classe de l'installation de HOMARD.
  """
#
#
#====
# 0. Les dfauts
#====   
#
# 0.1. ==> Le franais par dfaut
#
  langue_defaut = "fr"
  logiciel_nom_officiel = "Code_Aster"
#
# 0.2. ==> Les messages en francais
#
  texte_fr = {}
#
  texte_fr["Aide"]                     = ["Cette procdure sert  installer HOMARD.\n"]
  texte_fr["Aide_Fichier"]             = "A_Lire.txt"
#
  texte_fr["config_txt_lire"]          = "Nom du fichier 'config.txt' associ  cette version de " + logiciel_nom_officiel + " ?\n"
  texte_fr["Repertoire_Lire"]          = "Dans quel rpertoire doit-on installer HOMARD ?\n"
  texte_fr["Repertoire_Nom"]           = "Nom du rpertoire :"
  texte_fr["Repertoire_Absent"]        = "Ce rpertoire n'existe pas."
  texte_fr["Repertoire_Creation"]      = "Voulez-vous le crer ? (o/n) \n"
  texte_fr["Repertoire_Interdit"]      = "Ecriture interdite."
  texte_fr["Repertoire_remove"]        = "A la destruction de ce rpertoire"
  texte_fr["Repertoire_mkdir"]         = "A la cration de ce rpertoire"
  texte_fr["Repertoire_chdir"]         = "Au changement de rpertoire"
  texte_fr["Repertoire_Instal_Exec"]   = "... Rpertoire d'installation de l'excutable :"
#
  texte_fr["PYTHON_erreur"]            = "Impossible de dcoder PYTHON dans config.txt."
  texte_fr["REPOUT_erreur"]            = "Impossible de dcoder REPOUT dans config.txt."
#
  texte_fr["Fichier_Nom"]              = "Nom du fichier :"
  texte_fr["Fichier_Absent"]           = "Ce fichier est inconnu.\n"
  texte_fr["Fichier_ar"]               = "Probleme  la constitution de l'archive."
  texte_fr["Fichier_detar"]            = "Probleme  l'extraction de l'archive."
  texte_fr["Fichier_chmod"]            = "Probleme au changement de droits."
#
  texte_fr["Python_Lire"]              = "Nom de l'excutable python utilis pour " + logiciel_nom_officiel + " ?\n"
#
  texte_fr["HOMARD_Exec_Inconnu"]      = "L'excutable HOMARD est inconnu dans "
  texte_fr["HOMARD_Adaptation"]        = "..... Adaptation du maillage numro "
  texte_fr["HOMARD_Vers"]              = " vers le maillage numro "
  texte_fr["HOMARD_Erreur"]            = "Erreur  l'excution de HOMARD."
#
  texte_fr["Cas_Test_Lancement"]       = "\n. Lancement des cas tests"
  texte_fr["Cas_Test_Nom"]             = "\n... Cas test :"
  texte_fr["Cas_Test_Comparaison"]     = "..... Comparaison avec la rfrence"
  texte_fr["Cas_Test_Bilan_nblg"]      = "Les fichiers de bilan n'ont pas la mme longueur."
  texte_fr["Cas_Test_Bilan_lg_ref"]    = "Ligne dans la rfrence :     "
  texte_fr["Cas_Test_Bilan_lg"]        = "Ligne dans le calcul courant :"
  texte_fr["Cas_Test_Bilan_diff"]      = "Les fichiers de bilan diffrent."
  texte_fr["Cas_Test_OK"]              = "..... Cas test pass avec succs."
#
  texte_fr["Erreur_Numero"]            = ", erreur numro "
#
  texte_fr["Installation_OK"]          = "\nL'installation est russie.\n"
  texte_fr["Installation_Pb"]          = "\nL'installation a chou.\n"
  texte_fr["Installation_En_tete"]     = "\nInstallation de HOMARD version"
  texte_fr["Installation_HOMARD_Exec"] = "\n. Installation de l'excutable HOMARD"
  texte_fr["Installation_Couplage"]    = "\n. Installation des procdures de couplage " + logiciel_nom_officiel + "-HOMARD"
  texte_fr["Installation_Intranet"]    = "\n. Installation des documentations sous intranet"
  texte_fr["Installation_Cas_Test"]    = "\n. Installation des cas tests"
#
# 0.3. ==> Les messages en anglais
#   
  texte_en = {}
#
  texte_en["Aide"]                     = ["This setup is used to install HOMARD.\n"]
  texte_en["Aide_Fichier"]             = "Readme.txt"
#
  texte_en["config_txt_lire"]          = "Name of file 'config.txt' connected to this " + logiciel_nom_officiel + " release ?\n"
  texte_en["Repertoire_Lire"]          = "What is the directory for HOMARD installation ?\n"
  texte_en["Repertoire_Nom"]           = "Name of the directory :"
  texte_en["Repertoire_Absent"]        = "This directory does not exist."
  texte_en["Repertoire_Creation"]      = "Do you want creation ? (y/n) \n"
  texte_en["Repertoire_Interdit"]      = "No rights for writing."
  texte_en["Repertoire_remove"]        = "When removing this directory"
  texte_en["Repertoire_mkdir"]         = "When creating this directory"
  texte_en["Repertoire_chdir"]         = "When changing"
  texte_en["Repertoire_Instal_Exec"]   = "... Directory for exec installation :"
#
  texte_en["PYTHON_erreur"]            = "PYTHON cannot be found in config.txt."
  texte_en["REPOUT_erreur"]            = "REPOUT cannot be found in config.txt."
#
  texte_en["Fichier_Nom"]              = "Name of the file :"
  texte_en["Fichier_Absent"]           = "This file does not exist.\n"
  texte_en["Fichier_ar"]               = "Problem while creating archive file."
  texte_en["Fichier_detar"]            = "Problem while extracting from the archive file"
#
  texte_en["Python_Lire"]              = "Name of the python program which is used for  " + logiciel_nom_officiel + " ?\n"
#
  texte_en["HOMARD_Exec_Inconnu"]      = "The HOMARD programm is unknown in "
  texte_en["HOMARD_Adaptation"]        = "..... Adaptation from mesh # "
  texte_en["HOMARD_Vers"]              = " to mesh # "
  texte_en["HOMARD_Erreur"]            = "Error when HOMARD was running."
#
  texte_en["Cas_Test_Lancement"]       = "\n. Test cases execution"
  texte_en["Cas_Test_Nom"]             = "\n... Test case :"
  texte_en["Cas_Test_Comparaison"]     = "..... Comparizon with reference"
  texte_en["Cas_Test_Bilan_nblg"]      = "The lengths of the result files are not the same."
  texte_en["Cas_Test_Bilan_lg_ref"]    = "Line in reference :              "
  texte_en["Cas_Test_Bilan_lg"]        = "Line in the current computation :"
  texte_en["Cas_Test_Bilan_diff"]      = "Result files are not the same."
  texte_en["Cas_Test_OK"]              = "..... Test case passed."
#
  texte_en["Erreur_Numero"]            = ", error # "
#
  texte_en["Installation_OK"]          = "\nInstallation succeeded.\n"
  texte_en["Installation_Pb"]          = "\nInstallation failed.\n"
  texte_en["Installation_En_tete"]     = "\nInstallation of HOMARD release"
  texte_en["Installation_HOMARD_Exec"] = "\n. Install of HOMARD programm"
  texte_en["Installation_Couplage"]    = "\n. Install of coupling " + logiciel_nom_officiel + "-HOMARD programm"
  texte_en["Installation_Intranet"]    = "\n. Install of intranet documentation"
  texte_en["Installation_Cas_Test"]    = "\n. Install of test cases"
#
# 0.4. ==> Les messages generaux
#
  mess = {}
  mess["Ligne"] = "\n====================================================================\n"
  mess["Copyright"] = "\nCopyright Electricit de France - R&D - 1996, 1997, 2006\n"
#
# 0.5. Le systeme
#
  systeme = os.uname()[0]
#
#
########################## Debut de la fonction ##################################
#
#
  def __init__ (self, liste_option_init ) :
#
    """
    Le constructeur
    """
#
# 1.1. ==> Les options de base
#   
    langue = self.langue_defaut
    if "-en" in liste_option_init :
      langue = "en"
    self.langue = langue
#
    if "-v" in liste_option_init :
      self.option_ar    = "-cf"
      self.option_detar = "-xf"
      self.verbose = 1
    elif "-vmax" in liste_option_init :
      self.option_ar    = "-cvf"
      self.option_detar = "-xvf"
      self.verbose = 1
    else :
      self.option_ar    = "-cf"
      self.option_detar = "-xf"
      self.verbose = 0
#
# 1.2. ==> Les messages
#
    if self.langue == "fr" :
      self.message = self.texte_fr
    else :
      self.message = self.texte_en
    for cle in self.mess.keys() :
      self.message[cle] = self.mess[cle]
#
    self.Rep_Base = os.getcwd()
#
# 1.3. ==> Les informations particulires
#
    self.HOMARD_VERSION = "V8.5"
    self.Rep_Intranet = "Intranet"
    self.Rep_Proc_Couplage = "ASTER_HOMARD"
    self.prefixe = "homard"
#
#   
##########################  Fin de la fonction  ##################################
#
########################## Debut de la fonction ##################################
#
#
  def aide (self) :
#
    """
    Afficher les informations d'aide
    """
#
    fic_aide = os.path.join(os.getcwd(), self.message["Aide_Fichier"])
    if os.path.isfile(fic_aide) :
      fic = open (fic_aide, 'r' )
      les_lignes = fic.readlines()
      fic.close()
    else :
      les_lignes = self.message["Aide"]
      les_lignes.append(self.message["Copyright"])
    print self.message["Ligne"]
    for ligne in les_lignes :
      print ligne[0:-1]
    print self.message["Ligne"]
#
#
##########################  Fin de la fonction  ##################################
#
########################## Debut de la fonction ##################################
#
#
  def data (self) :
#
    """
    Lit les donnes pour installer HOMARD
    """
#
    message_erreur = None
#
    if self.verbose :
      print self.message["Installation_En_tete"], self.HOMARD_VERSION
#
# 1.1. ==> Nom du fichier de configuration de l'installation
#
    print self.message["Ligne"]
#
    encore = 1
    while encore :
      fic = raw_input(self.message["config_txt_lire"])
      if len(fic) > 0 :
        aux = string.lstrip(fic)
        fic = string.rstrip(aux)
        if os.path.isfile(fic) :
          break
        else :
          print self.message["Fichier_Nom"], fic
          print self.message["Fichier_Absent"]
#
    fic_bis = os.path.join(self.Rep_Base, fic)
    if os.path.isfile(fic_bis) :
      fic = fic_bis
#
# 1.2. ==> Dcodage du fichier de configuration de l'installation pour :
#          A. Nom du python utilis par le logiciel
#          B. Rpertoire des outils
#
#
    fichier = open (fic,"r")
    les_lignes = fichier.readlines()
    fichier.close()
    python_exe = None
    repout = None
    for ligne in les_lignes :
      l_aux = string.split(ligne)
      if len(l_aux) > 6 :
###        print ".... l_aux = ", l_aux
###        print ".... l_aux[0] = ", l_aux[0]
        if l_aux[0] == "PYTHON" :
###          print ".... l_aux = ", l_aux
          python_exe = l_aux[6]
        elif l_aux[0] == "REPOUT" :
###          print ".... l_aux = ", l_aux
          repout = l_aux[6]
#
###    print "python_exe  =", python_exe
    if python_exe is None :
      message_erreur = self.message["PYTHON_erreur"]
    else :
      if not os.path.isfile(python_exe) :
        print self.message["Fichier_Nom"], python_exe
        print self.message["Fichier_Absent"]
        message_erreur = self.message["Installation_Pb"]
#
###    print "repout =", repout
    if repout is None :
      message_erreur = self.message["REPOUT_erreur"]
    else :
      if not os.path.isdir(repout) :
        print self.message["Repertoire_Nom"], repout
        print self.message["Repertoire_Absent"]
        message_erreur = self.message["Installation_Pb"]
#
    self.PYTHON_EXE = os.path.normpath(python_exe)
    self.REPOUT = os.path.normpath(repout)
#
#
    if message_erreur is None :
      print self.message["Ligne"]
#
###    message_erreur = self.message["Installation_Pb"]
    return message_erreur
#
#
##########################  Fin de la fonction  ##################################
#
########################## Debut de la fonction ##################################
#
#
  def installation (self) :
#
    """
    Installer HOMARD
    """
#
# 1.0. ==> Initialisation
#
    fic_tar = tempfile.mktemp()
#
    self.Nom_Transfert = "HOMARD"
    self.Rep_Arch = os.path.join ( self.Rep_Base, self.Nom_Transfert )
#
    message_erreur = None
    erreur = 0
#
    while not erreur :
#
# 1.1. ==> Transfert de l'excutable
#          Attention : on ne peut pas procder par renommage car cela ne fonctionne pas
#                      si les fichiers ne sont pas sur les memes disques. On passe
#                      donc par un fichier d'archive tampon.
#
      print self.message["Installation_HOMARD_Exec"]
#
      HOMARD_Exe_loc = "HOMARD_" + self.HOMARD_VERSION + ".out"
#
# 1.1.1. ==> Le rpertoire o sera mis l'excutable.
#            . S'il n'existe pas, on le cre.
#            . S'il existe, on vrifie que l'on peut y aller et y crire. On ne le dtruit surtout pas,
#              car il peut contenir d'autres versions de HOMARD  conserver.
#
      self.Rep_Install_HOMARD = os.path.join(self.REPOUT, "HOMARD")
      self.Rep_Install_Exec = os.path.join(self.Rep_Install_HOMARD, self.systeme)
#
      if self.verbose :
        print self.message["Repertoire_Instal_Exec"], self.Rep_Install_Exec
#
      liste_rep = [self.Rep_Install_HOMARD, self.Rep_Install_Exec]
#
      for rep in liste_rep :
        err = [0]
        if not os.path.isdir(rep) :
          try :
            os.mkdir(rep)
          except os.error,err :
            print self.message["Repertoire_Nom"], rep
            message_erreur = self.message["Repertoire_mkdir"] + self.message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
        if err[0] :
          break
#
        if not os.access(rep, os.W_OK) or not os.access(rep, os.X_OK) :
          print self.message["Repertoire_Nom"], rep
          print self.message["Repertoire_Interdit"]
          break
#
# 1.1.2. ==> Archivage du point de dpart
#
      if self.verbose :
        print "... Rcupration du point de dpart"
#
      err = [0]
      try :
        os.chdir(self.Rep_Arch)
      except os.error,err :
        print self.message["Repertoire_Nom"], self.Rep_Arch
        message_erreur = self.message["Repertoire_chdir"] + self.message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
        break
#
      commande = "tar " + self.option_ar + " " + fic_tar + " " + HOMARD_Exe_loc
      erreur = os.system (commande)
      if erreur :
        message_erreur = self.message["Fichier_ar"]
        break
#
# 1.1.3. ==> Extraction
#
      if self.verbose :
        print "... Extraction dans", self.Rep_Install_Exec
#
      err = [0]
      try :
        os.chdir(self.Rep_Install_Exec)
      except os.error,err :
        print self.message["Repertoire_Nom"], self.Rep_Install_Exec
        message_erreur = self.message["Repertoire_chdir"] + self.message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
        break
#
      commande = "tar " + self.option_detar + " " + fic_tar
      erreur = os.system (commande)
      if erreur :
        message_erreur = self.message["Fichier_detar"]
        break
#
      self.HOMARD_Exe = os.path.join(self.Rep_Install_Exec, HOMARD_Exe_loc)
#
# 1.1.4. ==> Droit d'excution
#
      err = [0]
      try :
        os.chmod  (self.HOMARD_Exe, 0755)
      except os.error,err :
        print self.message["Fichier_Nom"], self.HOMARD_Exe
        message_erreur = self.message["Fichier_chmod"]
        break
#
# 1.2. ==> Transfert des documentations sous forme d'intranet
#          Attention : on ne peut pas procder par renommage car cela ne fonctionne pas
#                      si les rpertoires ne sont pas sur les memes disques. On passe
#                      donc par un fichier d'archive tampon.
#
      print self.message["Installation_Intranet"]
#
# 1.2.1. ==> Le rpertoire o sera mis l'intranet
#            . Si le rpertoire existe dj, on le supprime.
#
      if self.verbose :
        print "... Le rpertoire o sera mis l'intranet"
#
      rep = self.Rep_Intranet
      Rep_Install_Intranet = os.path.join(self.Rep_Install_HOMARD, rep)
#
      if os.path.isdir(Rep_Install_Intranet) :
        erreur = utilitaires.tue_rep ( Rep_Install_Intranet )
      if erreur :
        print self.message["Repertoire_Nom"], Rep_Install_Intranet
        message_erreur = self.message["Repertoire_remove"] + self.message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
        break
#
# 1.2.2. ==> Archivage du point de dpart
#
      if self.verbose :
        print "... Rcupration du point de dpart"
#
      err = [0]
      try :
        os.chdir(self.Rep_Arch)
      except os.error,err :
        print self.message["Repertoire_Nom"], self.Rep_Arch
        message_erreur = self.message["Repertoire_chdir"] + self.message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
        break
#
      commande = "tar " + self.option_ar + " " + fic_tar + " " + rep
      erreur = os.system (commande)
      if erreur :
        message_erreur = self.message["Fichier_ar"]
        break
#
# 1.2.3. ==> Extraction
#
      if self.verbose :
        print "... Extraction dans", self.Rep_Install_HOMARD
#
      err = [0]
      try :
        os.chdir(self.Rep_Install_HOMARD)
      except os.error,err :
        print self.message["Repertoire_Nom"], self.Rep_Install_HOMARD
        message_erreur = self.message["Repertoire_chdir"] + self.message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
        break
#
      commande = "tar " + self.option_detar + " " + fic_tar
      erreur = os.system (commande)
      if erreur :
        message_erreur = self.message["Fichier_detar"]
        break
#
# 1.3. ==> Transfert des procdures de couplage avec le logiciel
#          Attention : on ne peut pas procder par renommage car cela ne fonctionne pas
#                      si les rpertoires ne sont pas sur les memes disques. On passe
#                      donc par un fichier d'archive tampon.
#
#
      print self.message["Installation_Couplage"]
#
# 1.3.1. ==> Le rpertoire o seront mises les procdures de couplage
#            . Si le rpertoire existe dj, on le supprime.
#
      if self.verbose :
        print "... Le rpertoire o seront mises les procdures de couplage"
#
      Rep_Install_Couplage = os.path.join(self.Rep_Install_HOMARD, self.Rep_Proc_Couplage)
#
      if os.path.isdir(Rep_Install_Couplage) :
        erreur = utilitaires.tue_rep ( Rep_Install_Couplage )
      if erreur :
        print self.message["Repertoire_Nom"], Rep_Install_Couplage
        message_erreur = self.message["Repertoire_remove"] + self.message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
        break
#
# 1.3.2. ==> Archivage du point de dpart
#
      if self.verbose :
        print "... Rcupration du point de dpart"
#
      err = [0]
      try :
        os.chdir(self.Rep_Arch)
      except os.error,err :
        print self.message["Repertoire_Nom"], self.Rep_Arch
        message_erreur = self.message["Repertoire_chdir"] + self.message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
        break
#
      commande = "tar " + self.option_ar + " " + fic_tar + " " + self.Rep_Proc_Couplage
      erreur = os.system (commande)
      if erreur :
        message_erreur = self.message["Fichier_ar"]
        break
#
# 1.3.3. ==> Extraction
#
      if self.verbose :
        print "... Extraction dans", self.Rep_Install_HOMARD
#
      err = [0]
      try :
        os.chdir(self.Rep_Install_HOMARD)
      except os.error,err :
        print self.message["Repertoire_Nom"], self.Rep_Install_HOMARD
        message_erreur = self.message["Repertoire_chdir"] + self.message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
        break
#
      commande = "tar " + self.option_detar + " " + fic_tar
      erreur = os.system (commande)
      if erreur :
        message_erreur = self.message["Fichier_detar"]
        break
#
# 1.3.4. ==> Mise  jour du script de couplage avec le logiciel
#
      if self.verbose :
        print "... Mise  jour du script de couplage avec", self.logiciel_nom_officiel
#
# 1.3.4.1. ==> Lecture de la base
#
      lance_homard_base = os.path.join ( self.Rep_Arch, self.prefixe + "_base" )
      if not os.path.isfile(lance_homard_base) :
        print self.message["Fichier_Nom"], lance_homard_base
        message_erreur = self.message["Fichier_Absent"]
        break
#
      fic = open (lance_homard_base, 'r' )
      lignes = fic.readlines()
      fic.close()
#
# 1.3.4.2. ==> On crit toutes les lignes  l'identique, sauf :
#              . la premire o on doit mettre le bon python
#              . celles o des noms sont  changer
#
      lance_homard = os.path.join ( self.Rep_Install_HOMARD, self.Rep_Proc_Couplage, self.prefixe )
      if self.verbose :
        print "    fichier :", lance_homard
#
      err = [0]
      if os.path.isfile(lance_homard) :
        try :
          os.remove(lance_homard)
        except os.error,err :
          print self.message["Fichier_Nom"], lance_homard
          message_erreur = self.message["Fichier_remove"] + self.message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
      if err[0] :
        break
#
      fic = open (lance_homard, "w" )
#
      ligne = "#!" + self.PYTHON_EXE + "\n"
      fic.write(ligne)
      for ligne in lignes[1:] :
#
        la_ligne = ligne.split()
        if ( len(la_ligne) > 2 ) :
          if la_ligne[1] == "=" :
            if la_ligne[0] == "couplage_logiciel_homard_rep_defaut" or la_ligne[0] == "rep_homard_ref_defaut" :
              mot = self.Rep_Install_HOMARD
              ligne = ligne.replace( la_ligne[2][1:-1] , mot )
            elif la_ligne[0] == "version_homard_defaut" :
              mot = self.HOMARD_VERSION
              ligne = ligne.replace( la_ligne[2][1:-1] , mot )
#
        fic.write(ligne)
#
# 1.3.4.3. ==> Fin
#
      fic.close()
#
      os.chmod(lance_homard, 0755)
#
# 1.3.5. ==> Lien avec la procdure de lancement
#
      if self.verbose :
        print "... Lien avec la procdure de lancement"
#
      fic_arrivee = os.path.join(self.REPOUT, "homard")
      erreur = utilitaires.lien (lance_homard, fic_arrivee, "non")
#
# 1.4. ==> C'est fini
#
      break
#
#    print fic_tar
    if os.path.isfile(fic_tar) :
      os.chmod(fic_tar, 0644)
      err = [0]
      try :
        os.remove(fic_tar)
      except os.error,err :
        print self.message["Fichier_Nom"], fic_tar
        message_erreur = self.message["Fichier_remove"] + self.message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
#
    os.chdir(self.Rep_Base)
#
    if message_erreur is None :
      message_bis = self.message["Installation_OK"]
    else :
      message_bis = self.message["Installation_Pb"]
    return message_erreur, message_bis
#
#
##########################  Fin de la fonction  ##################################
#
########################## Debut de la fonction ##################################
#
#
  def cas_test (self) :
#
    """
    Lancement des cas_tests de vrification de l'installation HOMARD
    """
#
# 1.0. ==> Initialisation
#
    fic_tar = tempfile.mktemp()
#
    message_erreur = None
    erreur = 0
#
    while not erreur :
#
      print self.message["Installation_Cas_Test"]
#
# 1.1. ==> Transfert du rpertoire des cas_tests
#
      if self.verbose :
        print "... Le rpertoire o seront mis les cas-tests"
#
      Rep_Cas_Test_depart = os.path.join(self.Rep_Arch, "CAS_TESTS")
      Rep_Cas_Test = os.path.join(self.Rep_Install_HOMARD, "CAS_TESTS", self.HOMARD_VERSION)
#
# 1.1.1. ==> Cration ventuelle du rpertoire gnral des cas-tests
#
      rep = os.path.join(self.Rep_Install_HOMARD, "CAS_TESTS")
      err = [0]
      if not os.path.isdir(rep) :
        try :
          os.mkdir(rep)
        except os.error,err :
          print self.message["Repertoire_Nom"], rep
          message_erreur = self.message["Repertoire_mkdir"] + self.message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
      if err[0] :
        break
#
# 1.1.2. ==> Si le rpertoire des cas-tests de la version  installer existe dj, on le supprime, puis on le cree
#
      erreur = 0
      if os.path.isdir(Rep_Cas_Test) :
        erreur = utilitaires.tue_rep ( Rep_Cas_Test )
      if erreur :
        print self.message["Repertoire_Nom"], Rep_Cas_Test
        message_erreur = self.message["Repertoire_remove"] + self.message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
        break
#
      err = [0]
      try :
        os.mkdir(Rep_Cas_Test)
      except os.error,err :
        print self.message["Repertoire_Nom"], Rep_Cas_Test
        message_erreur = self.message["Repertoire_mkdir"] + self.message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
        break
#
# 1.2. ==> Transfert
#            Attention : on ne peut pas procder par renommage car cela ne fonctionne pas
#                        si les rpertoires ne sont pas sur les memes disques. On passe
#                        donc par un fichier d'archive tampon.
#
      if self.verbose :
        print "... Transfert"
#
# 1.2.1. ==> Archivage du point de dpart
#
      if self.verbose :
        print "... Rcupration du point de dpart"
#
      err = [0]
      try :
        os.chdir(Rep_Cas_Test_depart)
      except os.error,err :
        print self.message["Repertoire_Nom"], Rep_Cas_Test_depart
        message_erreur = self.message["Repertoire_chdir"] + self.message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
        break
#
      commande = "tar " + self.option_ar + " " + fic_tar + " *"
      erreur = os.system (commande)
      if erreur :
        message_erreur = self.message["Fichier_ar"]
        break
#
# 1.2.2. ==> Extraction
#
      if self.verbose :
        print "... Extraction dans", Rep_Cas_Test
#
      err = [0]
      try :
        os.chdir(Rep_Cas_Test)
      except os.error,err :
        print self.message["Repertoire_Nom"], Rep_Cas_Test
        message_erreur = self.message["Repertoire_chdir"] + self.message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
        break
#
      commande = "tar " + self.option_detar + " " + fic_tar
      erreur = os.system (commande)
      if erreur :
        message_erreur = self.message["Fichier_detar"]
        break
#
# 1.3. ==> Lancement des tests
#
      print self.message["Cas_Test_Lancement"]
#
      liste_cas = os.listdir ( os.getcwd() )
#
      for cas in liste_cas :
#
# 1.3.1. ==> Passage dans le rpertoire de calcul
#
        print self.message["Cas_Test_Nom"], cas
        Rep_Cas_Test_Resultat = os.path.join(Rep_Cas_Test, cas, "resultats")
        err = [0]
        try :
          os.chdir(Rep_Cas_Test_Resultat)
        except os.error,err :
          print self.message["Repertoire_Nom"], Rep_Cas_Test_Resultat
          message_erreur = self.message["Repertoire_chdir"] + self.message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
          break
        Rep_Cas_Test_Resultat_Ref = os.path.join(Rep_Cas_Test, cas,"resultats_ref")
#
# 1.3.2. ==> Initialisations
#
        fic_conf = os.path.join(Rep_Cas_Test_Resultat, "HOMARD.Configuration")
#
# 1.3.3. ==> Boucle sur toutes les adaptations possibles
#
        encore_bis = 1
        nbiterp1 = 0
        while encore_bis :
#
          nbiter = nbiterp1
          nbiterp1 = nbiter + 1
#
# 1.3.3.1. ==> Cration du fichier de configuration
#
          aux_nbiter = utilitaires.int_to_str2(nbiter)
          aux_nbiterp1 = utilitaires.int_to_str2(nbiterp1)
          suffixe = aux_nbiter + ".vers." + aux_nbiterp1
          fic_conf_spec = os.path.join(Rep_Cas_Test_Resultat_Ref, "HOMARD.Configuration." + suffixe)
          if not os.path.isfile(fic_conf_spec) :
            break
#
          shutil.copyfile(fic_conf_spec, fic_conf)
#
# 1.3.3.2. ==> Lancement de l'adaptation de nbiter vers nbiter+1
#
          print self.message["HOMARD_Adaptation"] + aux_nbiter + self.message["HOMARD_Vers"] + aux_nbiterp1
          erreur = os.system (self.HOMARD_Exe)
          if erreur :
            message_erreur = self.message["HOMARD_Erreur"]
            break
#
# 1.3.4. ==> Sortie prmature en cas d'erreur violente
#
        if message_erreur is not None :
          break
#
# 1.3.5. ==> Comparaisons :
#            Attention, il faut les faire seulement quand tout est fini, sinon
#                       il y a des incohrences de messages qui ne sont pas des erreurs
#
        if self.verbose :
          print self.message["Cas_Test_Comparaison"]
#
        nbiter_max = nbiter
        for nbiter in range(nbiter_max) :
          nbiterp1 = nbiter + 1
          aux_nbiterp1 = str(nbiterp1)
          if nbiterp1 < 10 :
            aux_nbiterp1 = "0" + aux_nbiterp1
          suffixe =  aux_nbiterp1 + ".bilan"
#
          Fic_Bilan_ref = os.path.join(Rep_Cas_Test_Resultat    , "apad." + suffixe)
          fic = open (Fic_Bilan_ref, 'r' )
          Bilan_Ref = fic.readlines()
          fic.close()
#
          Fic_Bilan     = os.path.join(Rep_Cas_Test_Resultat_Ref, "apad." + suffixe)
          if not os.path.isfile(Fic_Bilan) :
            print self.message["Fichier_Nom"], Fic_Bilan
            message_erreur = self.message["Fichier_Absent"]
            break
          fic = open (Fic_Bilan, 'r' )
          Bilan = fic.readlines()
          fic.close()
#
          nbligne = len(Bilan)
          if ( nbligne != len(Bilan_Ref) ) :
            message_erreur = self.message["Cas_Test_Bilan_nblg"]
            break
#
          for num_ligne in range(nbligne) :
            if Bilan[num_ligne] != Bilan_Ref[num_ligne] :
              if (     Bilan[num_ligne][5:9] == "Date" and     Bilan[num_ligne][13:21] == "creation" and
                   Bilan_Ref[num_ligne][5:9] == "Date" and Bilan_Ref[num_ligne][13:21] == "creation" ) :
                pass
              else :
                print self.message["Cas_Test_Bilan_lg_ref"], Bilan_Ref[num_ligne][0:-1]
                print self.message["Cas_Test_Bilan_lg"],     Bilan[num_ligne][0:-1]
                message_erreur = self.message["Cas_Test_Bilan_diff"]
#
# 1.3.4. ==> Bilan, avec sortie prmature en cas de diffrences
#
#
        if message_erreur is None :
          print self.message["Cas_Test_OK"]
        else :
          break
#
# 1.4. ==> C'est fini
#
      break
#
    if os.path.isfile(fic_tar) :
      os.chmod(fic_tar, 0644)
      err = [0]
      try :
        os.remove(fic_tar)
      except os.error,err :
        print self.message["Fichier_Nom"], fic_tar
        message_erreur = self.message["Fichier_remove"] + self.message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
#
    os.chdir(self.Rep_Base)
#
    if message_erreur is None :
      message_bis = self.message["Installation_OK"]
    else :
      message_bis = self.message["Installation_Pb"]
    return message_erreur, message_bis
#
#
##########################  Fin de la fonction  ##################################
#
##################################################################################
#
#
if __name__ == "__main__" :
#
  import sys
#
# 1. ==> Rcupration des arguments
#
  liste_option_main = sys.argv[1:]
#
  liste_aide = [ "-h", "-help", "-aide" ]
  aide = 0
  for mot_cle in liste_aide :
    if mot_cle in liste_option_main :
      aide = 1
#
# 2. ==> Cration de la classe
#
  install = INSTALLATION(liste_option_main)
#
# 3. ==> Fait-on une demande d'aide ? ou est-ce le traitement standard ?
#
  message_erreur_main = None
  message_bis_main = " "
#
# 3.0. ==> Aide
#
  if aide :
    install.aide()
  else :
#
# 3.1. ==> Les donnes
#
    message_erreur_main = install.data()
#
# 3.2. ==> Installation
#
    if message_erreur_main is None :
      message_erreur_main, message_bis_main = install.installation()
#
# 3.3. ==> Installation et passage des cas-tests
#
    if message_erreur_main is None :
      message_erreur_main, message_bis_main = install.cas_test()
#
# 4. ==> Bilan
#
  if message_erreur_main is None :
    print message_bis_main
  else :
    print "\n", message_erreur_main
    message_erreur_main = message_bis_main
#
  sys.exit(message_erreur_main)
